FILTER 함수는 부울(true/false) 배열을 기준으로 배열을 필터링합니다. 예:
인수
필수
설명
array
Y
필터링할 배열 또는 범위
include
Y
높이 또는 너비가 배열과 동일한 부울 배열
[if_empty]
N
포함된 배열의 모든 값이 비어 있는 경우(필터에서 아무것도 반환되지 않음) 반환할 값
참고: * FILTER 함수는 allowDynamicArray가 true인 경우에만 유효합니다. * FILTER 함수는 배열을 반환하며, 이 배열은 수식의 최종 결과인 경우 유출됩니다. * 데이터 집합이 빈 값을 반환할 가능성이 있는 경우에는 세 번째 인수([if_empty])를 사용합니다. 그렇지 않으면 #CALC! 오류가 발생합니다. * include 인수의 값이 오류(#N/A, #VALUE 등)이거나 부울로 변환될 수 없는 경우에는 FILTER 함수가 오류를 반환합니다.
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(_getElementById("ss"));
initSpread(spread);
};
var demoData = [
["Region","Sales Rep","Product","Units"],
["East","Tom","Apple",6380],
["West","Fred","Grape", 5619],
["North ","Amy","Pear", 4565],
["South","Sal","Banana", 5323],
["East","Fritz","Apple", 4394],
["West","Sravan","Grape", 7195],
["North ","Xi","Pear", 5231],
["South","Hector","Banana", 2427],
["East","Tom","Banana", 4213],
["West","Fred","Pear", 3239],
["North ","Amy","Grape", 6420],
["South","Sal","Apple", 1310],
["East","Fritz","Banana", 6274],
["West","Sravan","Pear", 4894],
["North ","Xi","Grape", 7580],
["South","Hector","Apple", 9814]
];
function initSpread(spread) {
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.name('FILTER');
sheet.defaults.colWidth = 80;
sheet.setColumnWidth(5, 20);
sheet.setColumnWidth(7, 20);
sheet.setText(0, 0, 'The FILTER function filters a range or array based on criteria you specify. Syntax: FILTER(array,include,[if_empty])');
var row = 2;
var col = 1;
var rowCount = 17;
applyTableStyleForRange(sheet, row, col, rowCount, 4);
applyTableStyleForRange(sheet, row, 6, 2, 1);
sheet.setArray(row, col, demoData);
sheet.setArray(row, 6, [["Criterion", "", "Product", "Units", "", "Total:"], [5000]]);
var formatter = '#,##0';
sheet.getRange(row + 1, col + 3, rowCount - 1, 1).formatter(formatter);
sheet.getCell(row + 1, 6).formatter(formatter);
sheet.getRange(row + 1, 9, rowCount, 1).formatter(formatter);
var formula = 'SUM(IF(E4:E19>G4,1,0))';
sheet.setFormula(row + 1, 11, formula);
// can't get value when calc service is suspended, use evaluateFormula instead
// rowCount = sheet.getValue(row + 1, 11) + 1;
rowCount = GC.Spread.Sheets.CalcEngine.evaluateFormula(sheet, formula) + 1;
applyTableStyleForRange(sheet, row, 8, rowCount, 2);
sheet.setArray(row, 6, [["Criterion", "", "Product", "Units", "", "Total:"], [5000]]);
sheet.setFormula(row + 1, 8, 'FILTER(D4:E19,E4:E19>G4,"")');
spread.resumeCalcService();
spread.resumePaint();
}
function applyTableStyleForRange(sheet, row, col, rowCount, colCount, options) {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.medium7, options);
sheet.tables.remove(tableName, 2 /* keep style */);
}
function _getElementById(id) {
return document.getElementById(id);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta name="spreadjs culture" content="ko-kr"/>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ko/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/ko/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/ko/purejs/node_modules/@mescius/spread-sheets-resources-ko/dist/gc.spread.sheets.resources.ko.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" style="width:100%; height: 100%"></div>
</div></body>
</html>
.sample {
position: relative;
height: 100%;
overflow: auto;
}
.sample::after {
display: block;
content: "";
clear: both;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 6px;
}
label {
display: block;
margin-bottom: 6px;
}
input {
margin-bottom: 5px;
padding: 2px 4px;
width: 100%;
box-sizing: border-box;
}
input[type=button] {
margin-bottom: 6px;
}
hr {
border-color: #fff;
opacity: .2;
margin: 5px 0;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

FILTER 함수는 부울(true/false) 배열을 기준으로 배열을 필터링합니다. 예:
인수
필수
설명
array
Y
필터링할 배열 또는 범위
include
Y
높이 또는 너비가 배열과 동일한 부울 배열
[if_empty]
N
포함된 배열의 모든 값이 비어 있는 경우(필터에서 아무것도 반환되지 않음) 반환할 값
참고: * FILTER 함수는 allowDynamicArray가 true인 경우에만 유효합니다. * FILTER 함수는 배열을 반환하며, 이 배열은 수식의 최종 결과인 경우 유출됩니다. * 데이터 집합이 빈 값을 반환할 가능성이 있는 경우에는 세 번째 인수([if_empty])를 사용합니다. 그렇지 않으면 #CALC! 오류가 발생합니다. * include 인수의 값이 오류(#N/A, #VALUE 등)이거나 부울로 변환될 수 없는 경우에는 FILTER 함수가 오류를 반환합니다.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
</div>
</template>
<script>
import Vue from "vue";
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ko';
import '@mescius/spread-sheets-vue'
GC.Spread.Common.CultureManager.culture("ko-kr");
import './styles.css';
const demoData = [
["Region","Sales Rep","Product","Units"],
["East","Tom","Apple",6380],
["West","Fred","Grape", 5619],
["North ","Amy","Pear", 4565],
["South","Sal","Banana", 5323],
["East","Fritz","Apple", 4394],
["West","Sravan","Grape", 7195],
["North ","Xi","Pear", 5231],
["South","Hector","Banana", 2427],
["East","Tom","Banana", 4213],
["West","Fred","Pear", 3239],
["North ","Amy","Grape", 6420],
["South","Sal","Apple", 1310],
["East","Fritz","Banana", 6274],
["West","Sravan","Pear", 4894],
["North ","Xi","Grape", 7580],
["South","Hector","Apple", 9814]
];
let App = Vue.extend({
name: "app",
methods:{
initSpread: function (spread) {
this.spread = spread;
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.name('FILTER');
sheet.defaults.colWidth = 80;
sheet.setColumnWidth(5, 20);
sheet.setColumnWidth(7, 20);
sheet.setText(0, 0, 'The FILTER function filters a range or array based on criteria you specify. Syntax: FILTER(array,include,[if_empty])');
var row = 2;
var col = 1;
var rowCount = 17;
this.applyTableStyleForRange(sheet, row, col, rowCount, 4);
this.applyTableStyleForRange(sheet, row, 6, 2, 1);
sheet.setArray(row, col, demoData);
sheet.setArray(row, 6, [["Criterion", "", "Product", "Units", "", "Total:"], [5000]]);
var formatter = '#,##0';
sheet.getRange(row + 1, col + 3, rowCount - 1, 1).formatter(formatter);
sheet.getCell(row + 1, 6).formatter(formatter);
sheet.getRange(row + 1, 9, rowCount, 1).formatter(formatter);
var formula = 'SUM(IF(E4:E19>G4,1,0))';
sheet.setFormula(row + 1, 11, formula);
// can't get value when calc service is suspended, use evaluateFormula instead
// rowCount = sheet.getValue(row + 1, 11) + 1;
rowCount = GC.Spread.Sheets.CalcEngine.evaluateFormula(sheet, formula) + 1;
this.applyTableStyleForRange(sheet, row, 8, rowCount, 2);
sheet.setArray(row, 6, [["Criterion", "", "Product", "Units", "", "Total:"], [5000]]);
sheet.setFormula(row + 1, 8, 'FILTER(D4:E19,E4:E19>G4,"")');
spread.resumeCalcService();
spread.resumePaint();
},
applyTableStyleForRange: function (sheet, row, col, rowCount, colCount, options) {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.medium7, options);
sheet.tables.remove(tableName, 2 /* keep style */);
}
}
});
new Vue({ render: h => h(App) }).$mount('#app');
</script>
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ko/vue/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/ko/vue/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.vue');
System.import('$DEMOROOT$/ko/lib/vue/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
#switchAutoMergeMode {
margin: 10px 0px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: 'vue-loader' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ko': 'npm:@mescius/spread-sheets-resources-ko/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.min.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
}
}
});
})(this);

FILTER 함수는 부울(true/false) 배열을 기준으로 배열을 필터링합니다. 예:
인수
필수
설명
array
Y
필터링할 배열 또는 범위
include
Y
높이 또는 너비가 배열과 동일한 부울 배열
[if_empty]
N
포함된 배열의 모든 값이 비어 있는 경우(필터에서 아무것도 반환되지 않음) 반환할 값
참고: * FILTER 함수는 allowDynamicArray가 true인 경우에만 유효합니다. * FILTER 함수는 배열을 반환하며, 이 배열은 수식의 최종 결과인 경우 유출됩니다. * 데이터 집합이 빈 값을 반환할 가능성이 있는 경우에는 세 번째 인수([if_empty])를 사용합니다. 그렇지 않으면 #CALC! 오류가 발생합니다. * include 인수의 값이 오류(#N/A, #VALUE 등)이거나 부울로 변환될 수 없는 경우에는 FILTER 함수가 오류를 반환합니다.
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ko';
GC.Spread.Common.CultureManager.culture("ko-kr");
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
var demoData = [
["Region", "Sales Rep", "Product", "Units"],
["East", "Tom", "Apple", 6380],
["West", "Fred", "Grape", 5619],
["North ", "Amy", "Pear", 4565],
["South", "Sal", "Banana", 5323],
["East", "Fritz", "Apple", 4394],
["West", "Sravan", "Grape", 7195],
["North ", "Xi", "Pear", 5231],
["South", "Hector", "Banana", 2427],
["East", "Tom", "Banana", 4213],
["West", "Fred", "Pear", 3239],
["North ", "Amy", "Grape", 6420],
["South", "Sal", "Apple", 1310],
["East", "Fritz", "Banana", 6274],
["West", "Sravan", "Pear", 4894],
["North ", "Xi", "Grape", 7580],
["South", "Hector", "Apple", 9814]
];
export function AppFunc() {
const initSpread = (spread) => {
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.name('FILTER');
sheet.defaults.colWidth = 80;
sheet.setColumnWidth(5, 20);
sheet.setColumnWidth(7, 20);
sheet.setText(0, 0, 'The FILTER function filters a range or array based on criteria you specify. Syntax: FILTER(array,include,[if_empty])');
var row = 2;
var col = 1;
var rowCount = 17;
applyTableStyleForRange(sheet, row, col, rowCount, 4);
applyTableStyleForRange(sheet, row, 6, 2, 1);
sheet.setArray(row, col, demoData);
sheet.setArray(row, 6, [["Criterion", "", "Product", "Units", "", "Total:"], [5000]]);
var formatter = '#,##0';
sheet.getRange(row + 1, col + 3, rowCount - 1, 1).formatter(formatter);
sheet.getCell(row + 1, 6).formatter(formatter);
sheet.getRange(row + 1, 9, rowCount, 1).formatter(formatter);
var formula = 'SUM(IF(E4:E19>G4,1,0))';
sheet.setFormula(row + 1, 11, formula);
// can't get value when calc service is suspended, use evaluateFormula instead
// rowCount = sheet.getValue(row + 1, 11) + 1;
rowCount = GC.Spread.Sheets.CalcEngine.evaluateFormula(sheet, formula) + 1;
applyTableStyleForRange(sheet, row, 8, rowCount, 2);
sheet.setArray(row, 6, [["Criterion", "", "Product", "Units", "", "Total:"], [5000]]);
sheet.setFormula(row + 1, 8, 'FILTER(D4:E19,E4:E19>G4,"")');
spread.resumeCalcService();
spread.resumePaint();
}
const applyTableStyleForRange = (sheet, row, col, rowCount, colCount, options) => {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.medium7, options);
sheet.tables.remove(tableName, 2 /* keep style */);
}
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
</div>;
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ko';
GC.Spread.Common.CultureManager.culture("ko-kr");
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
var demoData = [
["Region","Sales Rep","Product","Units"],
["East","Tom","Apple",6380],
["West","Fred","Grape", 5619],
["North ","Amy","Pear", 4565],
["South","Sal","Banana", 5323],
["East","Fritz","Apple", 4394],
["West","Sravan","Grape", 7195],
["North ","Xi","Pear", 5231],
["South","Hector","Banana", 2427],
["East","Tom","Banana", 4213],
["West","Fred","Pear", 3239],
["North ","Amy","Grape", 6420],
["South","Sal","Apple", 1310],
["East","Fritz","Banana", 6274],
["West","Sravan","Pear", 4894],
["North ","Xi","Grape", 7580],
["South","Hector","Apple", 9814]
];
export class App extends Component {
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread=>this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
</div>;
}
initSpread(spread) {
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.name('FILTER');
sheet.defaults.colWidth = 80;
sheet.setColumnWidth(5, 20);
sheet.setColumnWidth(7, 20);
sheet.setText(0, 0, 'The FILTER function filters a range or array based on criteria you specify. Syntax: FILTER(array,include,[if_empty])');
var row = 2;
var col = 1;
var rowCount = 17;
this.applyTableStyleForRange(sheet, row, col, rowCount, 4);
this.applyTableStyleForRange(sheet, row, 6, 2, 1);
sheet.setArray(row, col, demoData);
sheet.setArray(row, 6, [["Criterion", "", "Product", "Units", "", "Total:"], [5000]]);
var formatter = '#,##0';
sheet.getRange(row + 1, col + 3, rowCount - 1, 1).formatter(formatter);
sheet.getCell(row + 1, 6).formatter(formatter);
sheet.getRange(row + 1, 9, rowCount, 1).formatter(formatter);
var formula = 'SUM(IF(E4:E19>G4,1,0))';
sheet.setFormula(row + 1, 11, formula);
// can't get value when calc service is suspended, use evaluateFormula instead
// rowCount = sheet.getValue(row + 1, 11) + 1;
rowCount = GC.Spread.Sheets.CalcEngine.evaluateFormula(sheet, formula) + 1;
this.applyTableStyleForRange(sheet, row, 8, rowCount, 2);
sheet.setArray(row, 6, [["Criterion", "", "Product", "Units", "", "Total:"], [5000]]);
sheet.setFormula(row + 1, 8, 'FILTER(D4:E19,E4:E19>G4,"")');
spread.resumeCalcService();
spread.resumePaint();
}
applyTableStyleForRange(sheet, row, col, rowCount, colCount, options) {
var tableName = "tmpTable";
var TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.medium7, options);
sheet.tables.remove(tableName, 2 /* keep style */);
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ko/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/ko/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/ko/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
#switchAutoMergeMode {
margin: 10px 0px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ko': 'npm:@mescius/spread-sheets-resources-ko/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

FILTER 함수는 부울(true/false) 배열을 기준으로 배열을 필터링합니다. 예:
인수
필수
설명
array
Y
필터링할 배열 또는 범위
include
Y
높이 또는 너비가 배열과 동일한 부울 배열
[if_empty]
N
포함된 배열의 모든 값이 비어 있는 경우(필터에서 아무것도 반환되지 않음) 반환할 값
참고: * FILTER 함수는 allowDynamicArray가 true인 경우에만 유효합니다. * FILTER 함수는 배열을 반환하며, 이 배열은 수식의 최종 결과인 경우 유출됩니다. * 데이터 집합이 빈 값을 반환할 가능성이 있는 경우에는 세 번째 인수([if_empty])를 사용합니다. 그렇지 않으면 #CALC! 오류가 발생합니다. * include 인수의 값이 오류(#N/A, #VALUE 등)이거나 부울로 변환될 수 없는 경우에는 FILTER 함수가 오류를 반환합니다.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import GC from '@mescius/spread-sheets';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import '@mescius/spread-sheets-resources-ko';
GC.Spread.Common.CultureManager.culture("ko-kr");
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: '100%',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
const demoData = [
["Region","Sales Rep","Product","Units"],
["East","Tom","Apple",6380],
["West","Fred","Grape", 5619],
["North ","Amy","Pear", 4565],
["South","Sal","Banana", 5323],
["East","Fritz","Apple", 4394],
["West","Sravan","Grape", 7195],
["North ","Xi","Pear", 5231],
["South","Hector","Banana", 2427],
["East","Tom","Banana", 4213],
["West","Fred","Pear", 3239],
["North ","Amy","Grape", 6420],
["South","Sal","Apple", 1310],
["East","Fritz","Banana", 6274],
["West","Sravan","Pear", 4894],
["North ","Xi","Grape", 7580],
["South","Hector","Apple", 9814]
];
spread.options.allowDynamicArray = true;
let sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
sheet.name('FILTER');
sheet.defaults.colWidth = 80;
sheet.setColumnWidth(5, 20);
sheet.setColumnWidth(7, 20);
sheet.setText(0, 0, 'The FILTER function filters a range or array based on criteria you specify. Syntax: FILTER(array,include,[if_empty])');
let row = 2;
let col = 1;
let rowCount = 17;
this.applyTableStyleForRange(sheet, row, col, rowCount, 4);
this.applyTableStyleForRange(sheet, row, 6, 2, 1);
sheet.setArray(row, col, demoData);
sheet.setArray(row, 6, [["Criterion", "", "Product", "Units", "", "Total:"], [5000]]);
let formatter = '#,##0';
sheet.getRange(row + 1, col + 3, rowCount - 1, 1).formatter(formatter);
sheet.getCell(row + 1, 6).formatter(formatter);
sheet.getRange(row + 1, 9, rowCount, 1).formatter(formatter);
let formula = 'SUM(IF(E4:E19>G4,1,0))';
sheet.setFormula(row + 1, 11, formula);
// can't get value when calc service is suspended, use evaluateFormula instead
// rowCount = sheet.getValue(row + 1, 11) + 1;
rowCount = GC.Spread.Sheets.CalcEngine.evaluateFormula(sheet, formula) + 1;
this.applyTableStyleForRange(sheet, row, 8, rowCount, 2);
sheet.setArray(row, 6, [["Criterion", "", "Product", "Units", "", "Total:"], [5000]]);
sheet.setFormula(row + 1, 8, 'FILTER(D4:E19,E4:E19>G4,"")');
spread.resumeCalcService();
spread.resumePaint();
}
applyTableStyleForRange(sheet: GC.Spread.Sheets.Worksheet, row: number, col: number, rowCount: number, colCount:number, options?: any) {
let tableName = "tmpTable";
let TableThemes = GC.Spread.Sheets.Tables.TableThemes;
// use table to help set style then remove like convert table to range in Excel
sheet.tables.add(tableName, row, col, rowCount, colCount, TableThemes.medium7, options);
sheet.tables.remove(tableName, 2 /* keep style */);
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ko/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/ko/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/ko/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/ko/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/ko/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ko': 'npm:@mescius/spread-sheets-resources-ko/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);